package org.processmining.changepatterns.algorithms.modelchanges;

import org.deckfour.xes.classification.XEventClasses;
import org.processmining.changepatterns.algorithms.modelchanges.abstr.ChangePatternAbstr;
import org.processmining.plugins.etm.model.narytree.NAryTree;
import org.processmining.plugins.etm.model.narytree.TreeUtils;
import org.processmining.plugins.etm.model.narytree.conversion.NAryTreeToProcessTree;
import org.processmining.plugins.etm.model.narytree.conversion.ProcessTreeToNAryTree;
import org.processmining.processtree.ProcessTree;

public class AddFragment extends ChangePatternAbstr {

	public ProcessTree applyChangePattern(ProcessTree tree, int numberOfActivities) {

		ProcessTreeToNAryTree converter = new ProcessTreeToNAryTree();

		NAryTree naryTree = converter.convert(tree);
		XEventClasses classes = converter.getEventClasses();

		/**
		 * Adds a given number of leafs (i.e., activities) to the tree
		 */
		for (int i = 0; i < numberOfActivities; i++) {

			/**
			 * Find a leaf and a node
			 */
			int leafIndex = getRandomLeafIndex(naryTree);
			int nodeIndex = getRandomNodeIndex(naryTree);
			int numChild = naryTree.nChildren(nodeIndex);

			/**
			 * Add the node in a random child position.
			 */

			naryTree = naryTree.add(naryTree, leafIndex, nodeIndex, (int) Math.round(Math.random() * numChild));

		}

		/**
		 * normalizes the tree (removes nodes with 1 child)
		 */
		NAryTreeToProcessTree converter2 = new NAryTreeToProcessTree();
		return converter2.convert(TreeUtils.normalize(naryTree), classes);
	}

}
