package org.processmining.changepatterns.plugins;

import org.processmining.changepatterns.algorithms.modelchanges.AddFragment;
import org.processmining.changepatterns.algorithms.modelchanges.abstr.ChangePattern;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;

@Plugin(name = "Add Fragment in Process Tree ", parameterLabels = { "Process Tree"}, returnLabels = {
		"Process Tree" }, returnTypes = { ProcessTree.class }, help = "help is on the way...")
public class AddFragmentPlugin {

	@UITopiaVariant(affiliation = "Eindhoven University of Technology", author = "Alfredo Bolt", email = "a.bolt@tue.nl")
	@PluginVariant(variantLabel = "Add Fragment in Process Tree with UI", requiredParameterLabels = { 0 })
	public ProcessTree runUI(PluginContext context, ProcessTree input) {
		// Apply the algorithm depending on whether a connection already exists.

		return run(context, input);
	}

	@PluginVariant(variantLabel = "Add Fragment in Process Tree", requiredParameterLabels = { 0 })
	public ProcessTree runProcessTree(PluginContext context, ProcessTree input) {
		// Get the default parameters.

		return run(context, input);
	}

	private ProcessTree run(PluginContext context, ProcessTree input) {

		ChangePattern treeModifyer = new AddFragment();
		return treeModifyer.applyChangePattern(input, 1);
	}

}
